# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ....core.datetime_utils import serialize_datetime
from .denial_reason_content import DenialReasonContent


class ServiceLineDenialReason(pydantic.BaseModel):
    """
    The reason a given service line was denied within a given time range.
    A service line may be denied for different reasons over time, but only one reason at a time.
    """

    reason: typing.Optional[DenialReasonContent] = pydantic.Field(description=("Text of the denial reason\n"))

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        json_encoders = {dt.datetime: serialize_datetime}
